import Action from '../../types/Store/Actions';

export class UserState {
  login?: boolean;
  areaId: number;
  areaName?: string;
  birthDay?: string;
  createAt?: string;
  createLoginDate?: string;
  customerHead?: string;
  customerId: number;
  customerName?: string;
  customerPhone?: string;
  customerSex?: string;
  customerType?: string;
  email?: string;
  entranceDate?: string;
  hardwareAccount?: string;
  hardwarePwd?: string;
  hardwareState?: string;
  hardwarelastDate?: string;
  idBar: string;
  idCard?: string;
  isFirstRecharge?: number;
  lastLoginDate?: string;
  loginAccount?: string;
  loginPwd?: string;
  loginPwdSalt?: string;
  loginState?: string;
  state?: string;
  studentNo?: string;
  token?: string;
  updateAt?: string;
  updateLoginDate?: string;
  version?: string;
}

export const INITIAL_STATE = {
  login: false,
  areaId: undefined,
  areaName: '',
  birthDay: '',
  createAt: '',
  createLoginDate: '',
  customerHead: '',
  customerId: undefined,
  customerName: '',
  customerPhone: '',
  customerSex: '',
  customerType: '',
  email: '',
  entranceDate: '',
  hardwareAccount: '',
  hardwarePwd: '',
  hardwareState: '',
  hardwarelastDate: '',
  idBar: '',
  idCard: '',
  isFirstRecharge: undefined,
  lastLoginDate: '',
  loginAccount: '',
  loginPwd: '',
  loginPwdSalt: '',
  loginState: '',
  state: '',
  studentNo: '',
  token: '',
  updateAt: '',
  updateLoginDate: '',
  version: '',
};

export const updateUserInfo = (entity: UserState): Action => ({
  type: 'UPDATE_USERINFO',
  payload: entity,
});

export default function userinfo(
  state: UserState = INITIAL_STATE,
  actions: Action,
): UserState {
  switch (actions.type) {
    case 'UPDATE_USERINFO':
      return {
        ...state,
        ...actions.payload,
      };
    default:
      return state;
  }
}
